main
{
	// first curve

	p[2] = pointinfo(points[1]);
	p[3] = pointinfo(points[2]);
	p[4] = pointinfo(points[3]);
	p[1] = (p[2] - p[3]) * 3.0 + p[4];
	
	b = Curve(p[1], p[2], p[3], p[4]);

	
	// between curve
	for(i=1;i<pc - 2;i++)
	{
		p[1] = pnts[i];
		p[2] = pnts[i + 1];
		p[3] = pnts[i + 2];
		p[4] = pnts[i + 3];
		
		b = Curve(p[1], p[2], p[3], p[4]);
	}

	// last curve
	p[1] = pointinfo(points[1]);
	p[2] = pointinfo(points[2]);
	p[3] = pointinfo(points[3]);
	p[4] = (p[3] - p[2]) * 3.0 + p[1];
	
	b = Curve(p[1], p[2], p[3], p[4]);

	editend();
}
Curve: p1, p2, p3, p4
{
	var b1, b2, b3, b4;
	b1 = p2;
	b4 = p3;
	var l1, l2, r;
	l2 = vmag(p2 - p3);
	l1 = vmag(p1 - p2);
	if(l1 != 0.0)
	{
		r = l2 / l1;
		b2 = p2 + ((p3 - p2) - (p1 - p2) * r) / ((r + 1) * 3);
	}
	else
	{
		b2 = p2;
	}
	l1 = vmag(p3 - p4);
	if(l1 != 0.0)
	{
		r = l2/l1;
		b3 = p3 + ((p2 - p3) - (p4 - p3) * r) / ((r + 1) * 3);
	}
	else
	{
		b3 = p3;
	}
	t = 0;
	for(i=1;i<=seg;i++)
	{
		t = i / seg;
		a = BezierFunc(t, b1, b2, b3, b4);
		addpoint(a);
	}
	return(a);
}

BezierFunc: t, p1, p2, p3, p4
{
	var k1, k2, k3, k4, t1;
	t1 = 1 - t;
	k1 = t1 * t1;
	k4 = t * t;
	k2 = 3 * t * k1;
	k3 = 3 * t1 * k4;
	k1 *= t1;
	k4 *= t;
	return (p1 * k1 + p2 * k2 + p3 * k3 + p4 * k4);
}
/*
Explanatory notes: this is a Modeler script, although it can be applied to any of the architectures. It is important to note the point locations (and the methods used to extract them) that are being fed into the Curve() function (which will feed _its_ computations to the BezierFunc() function). If you see under the comment // first curve, 

	p[2] = pointinfo(points[1]);
	p[3] = pointinfo(points[2]);
	p[4] = pointinfo(points[3]);
	p[1] = (p[2] - p[3]) * 3.0 + p[4];

you will notice that p[1] is solved by an expression using the other point locations. p[1], in effect, is not an explicit point (e.g. one that you can see), rather, it is derived from the current set of points to help form the curve. This applies as well to the // last curve portion. Note that you need at least three points for these functions to work.
*/
